<author-form external-fields='[
          {
            "id": "classtype",
            "label": "Class",
            "description": "The classtype",
            "xsdDatatype": "xsd:anyURI",
            "minOccurs": "1",
            "maxOccurs": "1",
            "selectPattern": "SELECT ?value WHERE {?subject a <http://www.cidoc-crm.org/cidoc-crm/E53_Place>}",
            "insertPattern": "",
            "deletePattern": ""
          },
          {
            "id": "lookup",
            "label": "Place",
            "description": "Look up a geographic entity by place name",
            "xsdDatatype": "xsd:anyURI",
            "minOccurs": "1",
            "maxOccurs": "1",
            "selectPattern": "SELECT ?value WHERE {?subject a <http://www.cidoc-crm.org/cidoc-crm/E53_Place>}",
            "autosuggestionPattern": "PREFIX osm: <http://www.researchspace.org/resource/system/services/osm/>\n              SELECT DISTINCT ?label ?value WHERE {\n                SERVICE osm:NominatimSearchService {\n                  ?s osm:q ?__token__ ;\n                     osm:display_name ?label ;\n                     osm:wikidata ?wikidata ;\n                     osm:importance ?score .\n                }\n                BIND(URI(CONCAT(\"http://www.wikidata.org/entity/\", ?wikidata)) AS ?value)\n                FILTER(BOUND(?value)).\n              }\n              ORDER BY desc(?score)\n              LIMIT 10\n            ",
            "insertPattern": "",
            "deletePattern": ""
          }]'
          node='{{node}}' template='{{> form}}'
          external-insert-query="PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
                        PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
                        PREFIX wd: <http://www.wikidata.org/entity/>
                        PREFIX dct: <http://purl.org/dc/terms/>
                        PREFIX gvp: <http://vocab.getty.edu/ontology#>
                        PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
                        PREFIX gvp_lang: <http://vocab.getty.edu/language/>
                        PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
                        PREFIX crm: <http://www.cidoc-crm.org/cidoc-crm/>
                        INSERT { 
                          GRAPH <{graphIRI}> { 
                          <{iri}> a <http://www.cidoc-crm.org/cidoc-crm/E53_Place> ;
                            rdfs:label ?label ;
                            rdfs:comment ?description ;
                            crm:P168_place_is_defined_by ?geo_string .
                          }
                        } WHERE { 
                          { 
                              SERVICE <https://rs.lincsproject.ca/sparql> { 
                                  SELECT ?label ?description where { 
                                      <{iri}> rdfs:label ?label .
                                      OPTIONAL {<{iri}> rdfs:comment ?description}
                                      filter(lang(?label)='en')
                                  }
                              }
                          } UNION
                          { 
                              SERVICE <https://query.wikidata.org/sparql> { 
                                  SELECT ?label ?description ?geo_string where { 
                                      <{iri}> rdfs:label ?label .
                                      filter(lang(?label)='en') .
                                      optional {
                                        <{iri}> <http://schema.org/description> ?description .
                                        FILTER(lang(?description)='en') 
                                      } .
                                      optional {
                                        <{iri}> <http://www.wikidata.org/prop/P625> [ <http://www.wikidata.org/prop/statement/P625> ?geo ] .
                                        BIND(str(?geo) as ?geo_string)
                                      } .
                                  }
                                    
                              }
                              
                          }
                        }"

          frame='{{viewId}}'
          tokenizeLuceneQuery=false 
          escapeLuceneSyntax=false
          semantic-title='Place (crm:E53_Place)'
          semantic-title-iri='http://www.cidoc-crm.org/cidoc-crm/E53_Place'
          semantic-fields='[[fieldDefinitions 
                    classtype = "http://www.w3.org/1999/02/22-rdf-syntax-ns#type"
                    label = "http://www.w3.org/2000/01/rdf-schema#label"
                    core_hiddenLabel = "http://www.w3.org/2004/02/skos/core#hiddenLabel"
                    core_altLabel = "http://www.w3.org/2004/02/skos/core#altLabel"
                    P2_has_type_auto = "http://www.cidoc-crm.org/cidoc-crm/P2_has_type"
                    P2_has_type_tree = "http://www.cidoc-crm.org/cidoc-crm/P2_has_type"
                    same_as_auto = "http://www.w3.org/2002/07/owl#sameAs"
                    same_as_man = "http://www.w3.org/2002/07/owl#sameAs"
                    P129_is_about = "http://www.cidoc-crm.org/cidoc-crm/P129_is_about"
                    P89_falls_within = "http://www.cidoc-crm.org/cidoc-crm/P89_falls_within"
                    P74_has_current_or_former_residence = "http://www.cidoc-crm.org/cidoc-crm/P74_has_current_or_former_residence"
                    P1_is_identified_by = "http://www.cidoc-crm.org/cidoc-crm/P1_is_identified_by"
                    P168_place_is_defined_by = "http://www.cidoc-crm.org/cidoc-crm/P168_place_is_defined_by"
                    P76_has_contact_point = "http://www.cidoc-crm.org/cidoc-crm/P76_has_contact_point"
                    ]]'>
  <template id='form'> 
      <div class="form-scroll-area">
              <semantic-query query="SELECT DISTINCT ?profile ?title where {        
            graph <http://metadata.lincsproject.ca> { 
                ?g crm:P1_is_identified_by ?title_id .
                ?title_id crm:P2_has_type <http://vocab.getty.edu/aat/300417227> ;
                    crm:P190_has_symbolic_content ?title .	
                ?subject crm:P129_is_about ?g ; 
                    crm:P2_has_type lincs:applicationProfile ; 
                    crm:P1_is_identified_by ?id . 
                    ?id crm:P190_has_symbolic_content ?p.
                    BIND(IRI(?p) AS ?profile)
             } 
            {
              SELECT ?g WHERE { graph ?g {
                      ?subject a <http://www.cidoc-crm.org/cidoc-crm/E53_Place> .
                  }
              }
            }
        }" template='{{> template}}'>
          <template id="template">
            <div>
              <h2 style="padding: 10px 0px 10px 0px">Examine how this entity has been applied by LINCS:</h2>
              {{#each bindings}}
                <li style="padding-left: 25px;"><a target="_blank" href="{{profile.value}}" class="application_profile">{{title.value}}</a></li>
              {{/each}}
            </div>
          </template>  
        </semantic-query>
        <h2 style="padding-top: 25px;">General Properties</h2><semantic-form-hidden-input for="classtype" default-value="http://www.cidoc-crm.org/cidoc-crm/E53_Place"></semantic-form-hidden-input>
        <semantic-form-text-input for="label" languages='["en","fr","es","grc","it","la","de","pt","el","zh"]'></semantic-form-text-input>
        <semantic-form-text-input for="core_hiddenLabel" languages='["en","fr","es","grc","it","la","de","pt","el","zh"]'></semantic-form-text-input>
        <semantic-form-text-input for="core_altLabel" languages='["en","fr","es","grc","it","la","de","pt","el","zh"]'></semantic-form-text-input>
        <semantic-form-autocomplete-input for="P2_has_type_auto" label="has type (full-text lookup)">[[> forms/modal/E55_Type]]</semantic-form-autocomplete-input>
        <semantic-form-tree-picker-input for="P2_has_type_tree" label="has type (vocabulary tree)">[[> forms/modal/E55_Type]]</semantic-form-tree-picker-input>
        <semantic-form-autocomplete-input for="same_as_auto" label="same as (lookup)"></semantic-form-autocomplete-input>
            <div class="create_new"><semantic-link uri="http://www.researchspace.org/resource/ThinkingFrames?view=entity-editor"><button type="button" class="semantic-form-tree-picker-input__create-button btn btn-default"><span class="fa fa-plus btn-icon-left"></span><span>Create new</span></button></semantic-link></div>
        <semantic-form-text-input for="same_as_man" label="same as (manual input)"></semantic-form-text-input>
        <semantic-form-autocomplete-input for="P129_is_about"></semantic-form-autocomplete-input>
            <div class="create_new"><semantic-link uri="http://www.researchspace.org/resource/ThinkingFrames?view=entity-editor"><button type="button" class="semantic-form-tree-picker-input__create-button btn btn-default"><span class="fa fa-plus btn-icon-left"></span><span>Create new</span></button></semantic-link></div><h2>E53_Place Properties</h2>
        <semantic-form-autocomplete-input for="P89_falls_within">[[> forms/modal/E53_Place ]]</semantic-form-autocomplete-input>
        <semantic-form-autocomplete-input for="P74_has_current_or_former_residence">[[> forms/modal/E53_Place ]]</semantic-form-autocomplete-input>
        <semantic-form-autocomplete-input for="P1_is_identified_by">[[> forms/modal/E41_Appellation ]]</semantic-form-autocomplete-input>
        <semantic-form-text-input for="P168_place_is_defined_by"></semantic-form-text-input>
        <semantic-form-autocomplete-input for="P76_has_contact_point"></semantic-form-autocomplete-input>
        </div>
      <div class="form_submit">
        <button name="submit" class="btn btn-default">Save</button>
        <button name="delete" class="btn btn-default">Delete</button>
        <button name="reset" class="btn btn-default">Reset</button>
      </div>
  </template>
</author-form>
